#include "SI114X.h"
#include "software_i2c.h"
#include <xc.h>
#define _XTAL_FREQ 8000000

void initSI114X(void){
    soft_i2c_start();  
    soft_i2c_write(0x06); 
    soft_i2c_stop();  
    //reset na magistrali I2C. zalecany prze Sliabs przed komunikacja z Si1147
    
    i2c_write_byte(SI1145_ADDR,REG_COMMAND,COMM_RESET);
    __delay_ms(10);
    // reset Si1147 - tez zalecany na poczatek
    i2c_write_byte(SI1145_ADDR,REG_HW_KEY,HW_KEY_VAL0);
    //niezbedne do uruchoemienia Si1147
    __delay_ms(10); 
    i2c_write_byte(SI1145_ADDR,REG_UCOEF0,0x7B);
    i2c_write_byte(SI1145_ADDR,REG_UCOEF1,0x6B);
    i2c_write_byte(SI1145_ADDR,REG_UCOEF2,0x01);
    i2c_write_byte(SI1145_ADDR,REG_UCOEF3,0x00);  //parametry kalibracji
    
    Si114xParamSet(SI1145_ADDR,PARAM_CH_LIST,UV_TASK+IR_TASK+VIS_TASK); //wlaczenie wymaganych pomiarow
    __delay_ms(1);
      Si114xParamSet(SI1145_ADDR,PARAM_ALSVIS_ADC_MISC,VIS_RANGE); //ustawienie do pracy w slinym swietle slonecznym
    __delay_ms(1);
      Si114xParamSet(SI1145_ADDR,PARAM_ALSIR_ADC_MISC,IR_RANGE); //ustawienie do pracy w slinym swietle slonecznym
    __delay_ms(1);
}
unsigned int readUV(void){
    unsigned int uv;
      
    i2c_write_byte(SI1145_ADDR,REG_COMMAND,COMM_ALS_FORCE); // wymuszenie wykonania pomiarow z CHLIST
    __delay_ms(1); //wyniki pomiarow maja byc gotowe po 285us - czas z zapasem
    uv=i2c_read_byte(SI1145_ADDR,REG_UVINDEX0) + 256 * i2c_read_byte(SI1145_ADDR,REG_UVINDEX1);
    
    return uv;
}

void Si114xParamSet (unsigned char dev_addr, unsigned char RAM_addr, unsigned char value){
    i2c_write_byte(SI1145_ADDR,REG_COMMAND,COMM_NOP);
    i2c_read_byte(SI1145_ADDR,REG_RESPONSE);
    i2c_write_byte(SI1145_ADDR,REG_PARAM_WR,value);
    i2c_write_byte(SI1145_ADDR,REG_COMMAND,RAM_addr | COMM_PARAM_SET);
}